<?xml version="1.0" encoding="UTF-8"?>
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:p="http://primefaces.org/ui"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
>
<ui:composition template="template.xhtml">
    <ui:define name="content">
        <script type="text/javascript">
            function renderDiagram() {
                const resource = document.getElementById("content-form:xmlProcess").textContent;
                const BpmnViewer = window.BpmnJS;
                const viewer = new BpmnViewer({container: '#diagramCanvas', width: '100%', height: '100%'});
                const canvas = viewer.get('canvas');

                viewer.importXML(resource, function (err) {
                    if (err) {
                        console.log("Diagram rendering: " + err);
                    } else {
                        canvas.zoom('fit-viewport');
                        addMarkers(viewer);
                    }
                });
            }

            function addMarkers(viewer) {
                const injector = viewer.get('injector');
                const elementRegistry = injector.get('elementRegistry');
                const graphicsFactory = injector.get('graphicsFactory');

                const completedString = document.getElementById("content-form:flowCompleted").textContent;
                if (completedString !== '') {
                    completedString.split(",").forEach(function (item) {
                        markSequenceFlow(elementRegistry, graphicsFactory, item, '#80ff00', '#000');
                    });
                }

                const inProgressString = document.getElementById("content-form:flowInProgress").textContent;
                if (inProgressString !== '') {
                    inProgressString.split(",").forEach(function (item) {
                        markSequenceFlow(elementRegistry, graphicsFactory, item, '#009dff', '#000');
                    });
                }
            }

            function markSequenceFlow(elementRegistry, graphicsFactory, flow, colorFill, colorStroke) {
                const element = elementRegistry.get(flow);
                const gfx = elementRegistry.getGraphics(element);
                colorSequenceFlow(graphicsFactory, element, gfx, colorFill, colorStroke);
            }

            function colorSequenceFlow(graphicsFactory, sequenceFlow, gfx, colorFill, colorStroke) {
                const businessObject = sequenceFlow.businessObject, di = businessObject.di;
                di.set('stroke', colorStroke);
                di.set('fill', colorFill);
                graphicsFactory.update('connection', sequenceFlow, gfx);
            }
        </script>
        <h:form id="content-form">
            <p:dataTable id="table" var="t" value="#{processManagedBean.getProcesses()}"
                         rows="10"
                         paginator="true"
                         lazy="true"
                         paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                         currentPageReportTemplate="{startRecord}-{endRecord} из {totalRecords}"
                         rowsPerPageTemplate="5,10,20,50,{ShowAll|'Все'}"
                         emptyMessage="Нет экземпляров процессов">

                <p:column headerText="Идентификатор экземпляра" width="350">
                    <div style="white-space: nowrap">
                        <p:commandButton update="content-form:processModelDetail" actionListener="#{processManagedBean.selectInstance(t)}" oncomplete="renderDiagram();PF('processModelDialog').show()" icon="pi pi-search" title="View">
                            <f:setPropertyActionListener value="#{t}" target="#{processManagedBean.selectedInstance}" />
                            <f:setPropertyActionListener value="0" target="#{processManagedBean.selectedTab}" />
                        </p:commandButton>
                        <h:outputText value="#{t.processInstanceId}" style="margin-left: 10px; white-space: nowrap"/>
                    </div>
                </p:column>
                <p:column headerText="Дата и время запуска">
                    <h:outputText value="#{processManagedBean.getDateString(t.date)}" />
                </p:column>
                <p:column headerText="Бизнес ключ">
                    <h:outputText value="#{t.businessKey}" />
                </p:column>
                <p:column headerText="Класс процессов">
                    <h:outputText value="#{t.processDefinitionKey}" />
                </p:column>
                <p:column headerText="Статус процесса">
                    <h:outputText value="#{t.lifecycleType.getCaption()}" />
                </p:column>
                <p:column headerText="Дата завершения">
                    <h:outputText value="#{processManagedBean.getDateString(t.endDate)}" />
                </p:column>
                <p:column headerText="Время выполнения">
                    <h:outputText value="#{processManagedBean.getRunTime(t.date, t.endDate)}" />
                </p:column>
            </p:dataTable>

            <p:dialog header="Экземпляр процесса" widgetVar="processModelDialog" modal="true">
                <p:scrollPanel id="processModelDetail" style="width:800px; min-height:600px; text-align:left; border: none!important;">
                    <h:outputText style="display: none" id="xmlProcess" value="#{processManagedBean.getXml()}"/>
                    <h:outputText style="display: none" id="flowInProgress" value="#{processManagedBean.getFlowInProgress()}"/>
                    <h:outputText style="display: none" id="flowCompleted" value="#{processManagedBean.getFlowCompleted()}"/>

                    <p:tabView activeIndex="#{processManagedBean.selectedTab}">
                        <p:tab title="Модель">
                            <div id="diagramCanvas" style="height: 600px;"></div>
                        </p:tab>
                        <p:tab title="Переменные">
                            <p:dataTable id="variableTable" var="v" value="#{processManagedBean.getVariables()}"
                                         rows="10"
                                         paginator="true"
                                         lazy="true"
                                         paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                                         currentPageReportTemplate="{startRecord}-{endRecord} из {totalRecords}"
                                         rowsPerPageTemplate="5,10,20,50,{ShowAll|'Все'}"
                                         emptyMessage="Нет данных">
                                <p:column headerText="Появление">
                                    <h:outputText value="#{processManagedBean.getDateString(v.date)}" />
                                </p:column>
                                <p:column headerText="Переменная">
                                    <h:outputText value="#{v.variableName}" />
                                </p:column>
                                <p:column headerText="Значение">
                                    <h:outputText value="#{v.textValue}" />
                                </p:column>
                                <p:column headerText="Тип">
                                    <h:outputText value="#{v.serializerName}" />
                                </p:column>
                            </p:dataTable>
                        </p:tab>
                        <p:tab title="Элементы процесса">
                            <p:dataTable id="activityTable" var="a" value="#{processManagedBean.getActivities()}"
                                         rows="10"
                                         paginator="true"
                                         lazy="true"
                                         paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                                         currentPageReportTemplate="{startRecord}-{endRecord} из {totalRecords}"
                                         rowsPerPageTemplate="5,10,20,50,{ShowAll|'Все'}"
                                         emptyMessage="Нет данных">
                                <p:column headerText="Старт">
                                    <h:outputText value="#{processManagedBean.getDateString(a.date)}" />
                                </p:column>
                                <p:column headerText="Задача">
                                    <h:outputText value="#{a.activityId}" />
                                </p:column>
                                <p:column headerText="Исполнение">
                                    <h:outputText value="#{a.lifecycleType.getCaption()}" />
                                </p:column>
                                <p:column headerText="Завершение">
                                    <h:outputText value="#{processManagedBean.getDateString(a.endDate)}" />
                                </p:column>
                                <p:column headerText="Время выполнения">
                                    <h:outputText value="#{processManagedBean.getRunTime(a.date, a.endDate)}" />
                                </p:column>
                            </p:dataTable>
                        </p:tab>
                    </p:tabView>
                </p:scrollPanel>
                <f:facet name="footer">
                    <p:commandButton value="Закрыть" update="content-form:table" onclick="PF('processModelDialog').hide()" styleClass="ui-button-warning"/>
                </f:facet>
            </p:dialog>
        </h:form>
    </ui:define>
</ui:composition>
</html>